//
//  MyClass.m
//  ExampleFramework
//
//  Created by Justin Anderson on 12/16/19.
//  Copyright © 2019 Justin Anderson. All rights reserved.
//

#import "MyClass.h"

@interface MyClass ()
@property (nonnull, nonatomic, copy) NSString *myString;
@end

@implementation MyClass

- (instancetype)initWithString:(NSString *)string
{
    self = [super init];
    if (self) {
        _myString = string;
    }
    return self;
}

-(NSString *)doSomethingWithMyClass:(MyClass *)myClass
{
    return [NSString stringWithFormat:@"%@ + %@", self.myString, myClass.myString];
}

- (nonnull id)copyWithZone:(nullable NSZone *)zone {
    return self;
}

@end

@implementation MyClass (Example)

- (NSString *)example_doSomethingWithMyProtocol:(id<MyProtocol>)protocol
{
    if (![protocol isKindOfClass:[MyClass class]]){
        return nil;
    }

    return [self doSomethingWithMyClass:protocol];
}

@end
